#include "DataType.h"


std::ostream& std::operator << (std::ostream& out, const std::vector <int>& elem) {
	for (auto& i : elem) {
		out << i << " ";
	}
	out << std::endl;
	return out;
}

std::ostream& std::operator << (std::ostream& out, const std::set<int>& elem) {
	for (auto& i : elem) {
		out << i << " ";
	}
	out << std::endl;
	return out;
}

std::ostream& std::operator << (std::ostream& out, const std::vector<Node>& elem) {
	for_each(elem.begin(), elem.end(), [&](const auto& i) {
		out << "   ID node: " << i.ID_Node << std::endl;
		out << "   Coordinateates: ";
		for_each(i.Coordinate.begin(), i.Coordinate.end(), [&](const auto& j) {
			out << j << " ";
			});
		out << std::endl << "   Flag: " << i.flag << std::endl << std::endl;
		});
	return out;
}

std::ostream& std::operator << (std::ostream& out, const std::set <FiniteElement>& elem) {
	for_each(elem.begin(), elem.end(), [&](const auto& i) {
		out << "   ID_FiniteElement: " << i.ID_FiniteElement << std::endl;
		out << "   ID_Material: " << i.ID_Material << std::endl;
		out << "   ID_Nodes: ";
		for_each(i.ID_Nodes.begin(), i.ID_Nodes.end(), [&](const auto& j) {
			out << j << " ";
			});
		out << std::endl << std::endl;
		});
	return out;
}
std::ostream& std::operator << (std::ostream& out, const std::vector <FiniteElement>& elem) {
	for_each(elem.begin(), elem.end(), [&](const auto& i) {
		out << "   ID_FiniteElement: " << i.ID_FiniteElement << std::endl;
		out << "   ID_Material: " << i.ID_Material << std::endl;
		out << "   ID_Nodes: ";
		for_each(i.ID_Nodes.begin(), i.ID_Nodes.end(), [&](const auto& j) {
			out << j << " ";
			});
		out << std::endl << std::endl;
		});
	return out;
}

std::ostream& std::operator << (std::ostream& out, const std::vector <BoundaryFiniteElement>& elem) {
	for_each(elem.begin(), elem.end(), [&](const auto& i) {
		out << "   ID_Element: " << i.ID_Element << std::endl;
		out << "   ID_Boundary: " << i.ID_Boundary << std::endl;
		out << "   ID_Nodes: ";
		for_each(i.ID_Nodes.begin(), i.ID_Nodes.end(), [&](const auto& j) {
			out << j << " ";
			});
		out << std::endl << std::endl;
		});
	return out;
}

std::ostream& std::operator << (std::ostream& out, const std::vector<std::set<int>>& elem) {
	int n = 1;
	for_each(elem.begin(), elem.end(), [&](const auto& i) {
		out << "Container_" << n << std::endl;
		out << i;
		++n;
		});
	return out;
}